3 # © 2023–2024 Lady [@ Lady’s Computer].
5 # This Source Code Form is subject to the terms of the Mozilla Public
6 # License, v. 2.0. If a copy of the MPL was not distributed with this
7 # file, You can obtain one at https://mozilla.org/MPL/2.0/.
9 # This Makefile requires rsync 3 or newer.
11 RSYNC_FLAGS = -Oclmrtvz
13 RSYNC_FILTER = .rsync-filter
15 SOURCE_CHARSET = utf-8-mac
17 DESTINATION_HOST = computer
18 DESTINATION_PATH = lady/www
19 DESTINATION = $(DESTINATION_HOST):$(DESTINATION_PATH)
20 DESTINATION_CHARSET = utf-8
25 SHUSHE_OPTIONS = 'INCLUDEDIR=sources/INCLUDE' 'TRANSFORMS=$(wildcard transforms/*.xslt) $(wildcard $(SHUSHE)/transforms/*.xslt)'
29 @$(MAKE) -f $(SHUSHE)/GNUmakefile install $(SHUSHE_OPTIONS)
33 @$(MAKE) -f $(SHUSHE)/GNUmakefile list $(SHUSHE_OPTIONS)
36 @if [ ! -f .grass ]; then echo 'Error: The website has not been built yet!' >&2; echo 'Run `make` before syncing.' >&2; exit 1; fi
37 @if buildtime=$$(stat -f '%m' .grass) && committime=$$(git log -1 --format='%ct' | awk '{print $$NF}') && [ "$$committime" -gt "$$buildtime" ]; then echo 'Error: A commit was made after the last build!' >&2; echo 'Run `make` before syncing.' >&2; exit 1; fi
39 ensure-branch-up-to-date:
41 @if ! git merge-base --is-ancestor @{u} HEAD; then echo 'Error: This branch is currently out‐of‐date!' >&2; echo 'Pull in changes with `git pull` before syncing.' >&2; exit 1; fi
44 @if output=$$(git status --porcelain) && [ ! -z "$$output" ]; then echo 'Error: There are uncommitted changes!' >&2; echo 'Commit changes and run `make` before syncing.' >&2; exit 1; fi
46 dry-sync: ensure-clean$(if $(GIT_FORCE),, ensure-branch-up-to-date) ensure-build
47 cd public && $(RSYNC) $(RSYNC_FLAGS) --del --dry-run --filter=". ../$(RSYNC_FILTER)" --iconv=$(SOURCE_CHARSET),$(DESTINATION_CHARSET) $(RSYNC_OPTIONS) . $(DESTINATION)
49 sync: ensure-clean$(if $(GIT_FORCE),, ensure-branch-up-to-date) ensure-build
50 cd public && $(RSYNC) $(RSYNC_FLAGS) --del --filter=". ../$(RSYNC_FILTER)" --iconv=$(SOURCE_CHARSET),$(DESTINATION_CHARSET) $(RSYNC_OPTIONS) . $(DESTINATION)
51 git push$(if $(GIT_FORCE), --force,)
53 .PHONY: build dry-sync ensure-branch-up-to-date ensure-build ensure-clean sync;